#include <pwd.h>
#include <shadow.h>
#include <errno.h>
#include <unistd.h>
#include <stdio.h>
#include <dlfcn.h>
#include <security/pam_appl.h>
#include <security/pam_modules.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <dlfcn.h>
#include <netdb.h>
#include <string.h>
#include <pwd.h>
#include <shadow.h>
#include <syslog.h>

#include <arpa/inet.h>
#include <netdb.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/socket.h>

#include "pam_ru.h"

/* Necessary for become to work properly with pam_ru */
struct ruauthdata {
  char *ph_path;
  char *ru_agent;
};

pam_sm_authenticate(pamh, flags, argc, argv)
	pam_handle_t 	*pamh;
	int 	flags;
	int 	argc;
	const char 	**argv;
{
   struct pam_conv *conv;
   struct pam_message *msgvec[1];
   struct pam_response *respvec[1];
   struct pam_message msg;
   int ret, i, top = 0;
   int become = 0;
   char *tmp;
   char *user;
   char *password;
   char *spassword;

   unsigned long time_mul = 15000000;
   int debdev = 0;
   int errno;

   msgvec[0] = &msg;

   for (i = 0; i < argc; i++) {
      if (!strcmp("debug", argv[i])) debdev = 1;
      else if (!strcmp("expire", argv[i])) time_mul = 60;
      else if (!strncmp("exp=", argv[i], 4)) {
         tmp = strdup(argv[i]);
         tmp = tmp + 4;
         if (tmp) {
            time_mul = atol(tmp);
            if (time_mul > 15000000) time_mul = 15000000;
         }
         else time_mul = 60;

         if (!time_mul) time_mul = 60;
      }
   }

   if (debdev) {
      for (i = 0; i < argc; i++) debout("ru_save - arg %s", argv[i]);
      debout("ru_save - current expiration time: %ld minutes", time_mul);
   }

/*
 * Retrieving the necessary password information
 */

   if (debdev) debout("ru_save - Getting conversation.");

   if (pam_get_item(pamh, PAM_CONV, (const void **)& conv) != PAM_SUCCESS)
      return PAM_SERVICE_ERR;

   if (debdev) debout("ru_save - Getting user.");

   if (pam_get_item(pamh, PAM_USER, (const void **)&user) != PAM_SUCCESS || 
       user == NULL || *user == 0 ) {

#ifdef undef
   msg.msg_style = PAM_PROMPT_ECHO_ON;
   msg.msg = "login: ";

   if ((*(conv->conv)) (1, msgvec, respvec, conv->appdata_ptr) != PAM_SUCCESS)
      return PAM_AUTH_ERR;

   if (pam_set_item(pamh, PAM_USER, (void *)respvec[0]->resp) != PAM_SUCCESS)
      return PAM_SERVICE_ERR;
#endif


      if (pam_get_user(pamh, (const char **)&user, NULL) != PAM_SUCCESS || user == NULL ||
          *user == 0)
         return PAM_USER_UNKNOWN;

   }

   if (debdev) debout("ru_save - user = %s", user);

   if (debdev) debout("ru_save - Getting password.");

   if (pam_get_item(pamh, PAM_AUTHTOK, (const void **)&password) != PAM_SUCCESS ||
       password == NULL) {


      if (debdev) debout("ru_save - password wasn't set.");
      top = 1;

      msg.msg_style = PAM_PROMPT_ECHO_OFF;
      msg.msg = "Token: ";

      if ((*(conv->conv)) (1, (const struct pam_message **)msgvec, respvec, conv->appdata_ptr) != PAM_SUCCESS)
         return PAM_AUTH_ERR;
     
      password = respvec[0]->resp;
   }

 
   if (password) {

      if (debdev) debout("ru_save - password has been set.");
      if (debdev) debout("ru_save - It is now %s", password);

      if (!strncmp(password, "save ", 5)) {

         if (debdev) debout("ru_save - save pass = %s", password);
         if (pam_set_item(pamh,PAM_OLDAUTHTOK, (void *)password) != PAM_SUCCESS)
         return PAM_SERVICE_ERR;

         spassword = strdup(password + 5);
         if (debdev) debout("ru_save - %s", spassword);


         if (strstr(password, ":")) become = 1;
         if (debdev) {
	   debout("ru_save - calling ru_save.");
           debout("ru_save - user = %s, password = %s, old_pass = %s", user, spassword, password);
	 }

         ret = ru_save(user, password, pamh, 0, debdev, time_mul);
         if (debdev) debout("ru_save - return code for ru_save = %d", ret);
         if (!ret) {
            spassword = NULL;
            if (pam_set_item(pamh, PAM_OLDAUTHTOK, (void *)spassword) != PAM_SUCCESS)
            return PAM_SERVICE_ERR;

            return PAM_SUCCESS;
         }
         else {
            if (debdev) debout("ru_save - storing old pass %s.", spassword);
            if (pam_set_item(pamh, PAM_AUTHTOK, (void *)spassword) != PAM_SUCCESS)
         return PAM_SERVICE_ERR;
 
            return PAM_AUTH_ERR;
         }
      }
      else {
         if (debdev) debout("ru_save - not a save password.  moving on.");
         if (debdev) {
            debout("ru_save - user = %s", user);
            debout("ru_save - pass = %s", password);
         }
         if (top) {
            if (pam_set_item(pamh, PAM_AUTHTOK, (void *)password) != PAM_SUCCESS)
               return PAM_SERVICE_ERR;
         }
         return PAM_AUTH_ERR;
      }

   }
   else return PAM_AUTH_ERR;

}

int pam_sm_setcred(pamh, flags, argc, argv)
	pam_handle_t 	*pamh;
	int 	flags;
	int 	argc;
	const char 	**argv;
{

   return PAM_SUCCESS;
}
