#include <pwd.h>
#include <shadow.h>
#include <errno.h>
#include <unistd.h>
#include <stdio.h>
#include <dlfcn.h>
#include <security/pam_appl.h>
#include <security/pam_modules.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <dlfcn.h>
#include <netdb.h>
#include <string.h>
#include <pwd.h>
#include <shadow.h>
#include <syslog.h>
#include <stdlib.h>

#include <arpa/inet.h>
#include <netdb.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/socket.h>

#include "pam_ru.h"

/* Necessary for become to work properly with pam_ru */
struct ruauthdata {
  char *ph_path;
  char *ru_agent;
};

int errno;

int ru_save(char *user, char *password, pam_handle_t *pamh, int save, 
            int debdev, long time_mul) {
   int cachefile; 
   char passbuf[80] = { (char)NULL };
   char tmp[300];
   char *service;
   char *rhost;
   struct stat statb;
   struct timeval timeb;
   int error;
   int become = 0;

   char bbuffer[512];
   char *buser;
   char *bpoint;

   char *group_h;
   char *user_h;

   if (gettimeofday(&timeb, 0)) {
      if (debdev) debout("ru_save - error getting the time of day.");
      return -1;
   } 

   if (stat("/var/spool/save-cache/", &statb)) {
	return -1;
   }

   if (debdev) debout("ru_save - Inside pam_save");

/* Get the service */
   if (pam_get_item(pamh, PAM_SERVICE, (void *)&service) == PAM_SUCCESS) {
      sprintf(tmp, "/var/spool/save-cache/%s-cache", service);
      if (stat(tmp, &statb)) mkdir(tmp, 0700);

/* Get the remote host */
      if (pam_get_item(pamh, PAM_RHOST, (const void **)&rhost) == PAM_SUCCESS) {

/* Convert the host to an IP address */
         if (rhost) {
	   struct in_addr in;
	   struct hostent *hp=NULL;
	   struct hostent ret;
	   char hostbuf[512];
	   char **IP;

            gethostbyname_r(rhost, &ret, 
			    hostbuf, sizeof(hostbuf), &hp, &error);

/* Use the host information */
            if (hp) {
               IP = hp->h_addr_list;
               (void) memcpy(&in.s_addr, *IP, sizeof(in.s_addr));
         
/* Decide whether the account is a become account or a normal account. */
/* The file name will be of the form %{name}-%{IP address} or          */
/* help-%{name}-%{IP address}.				               */

/* NEW BECOME HANDLING  */
               if (pam_get_data(pamh, "become_user", (const void **)&user_h) == PAM_SUCCESS) {
                  if (debdev) debout("ru_save -working with a become account.");
                  
                  if (pam_get_data(pamh, "become_group", (const void **)&group_h) == PAM_SUCCESS) {
                   if (debdev)  debout("ru_save - user handle %s", user_h);
                     sprintf(tmp, "/var/spool/save-cache/%s-cache/%s-%s-%s",
                                      service, group_h, user_h, inet_ntoa(in));
                   if (debdev) debout("ru_save - /var/spool/save-cache/%s-cache/%s-%s-%s",
                                         service, group_h, user_h, inet_ntoa(in));
                  }
               }
               else {
/* Soon to be deprecated in favor of forcing the use of   */
/* the pam_become module				  */
               if (become) {
 
/* Break up the user:password token to get the first name */

                  strncpy(bbuffer, password, sizeof(bbuffer)-1);
                  bbuffer[sizeof(bbuffer)-1] = '\0';
                  bpoint = strchr(bbuffer, ' ');
                  *bpoint = '\0';
                  buser = bpoint + 1;
                  bpoint = strchr(buser, ':');
                  *bpoint = '\0';
                  
                  sprintf(tmp, "/var/spool/save-cache/%s-cache/%s-%s-%s",
                                         service, user, buser, inet_ntoa(in));
                  if (debdev)
                  debout("ru_save - /var/spool/save-cache/%s-cache/%s-%s-%s",
                                         service, user, buser, inet_ntoa(in));
               }
               else {
                  sprintf(tmp, "/var/spool/save-cache/%s-cache/%s-%s", service,
                                               user, inet_ntoa(in));
                  if (debdev)
                  debout("ru_save - /var/spool/save-cache/%s-cache/%s-%s", service,
                                               user, inet_ntoa(in));
               }
               }


/* To save or not to save */
               if (!save) {

/* Get the status of the cached password file */
                  if (!stat(tmp, &statb)) {

/* Check that the password hasn't expired */
                     if (timeb.tv_sec < (statb.st_mtime + time_mul * 60)) {
                        cachefile = open(tmp, O_RDONLY);
     
/* Check that the file exists */
                        if (cachefile) {
                     
/* Read the cached password */
                           if (read (cachefile, passbuf, sizeof(passbuf)) == sizeof(passbuf)
                            && !strncmp(passbuf, password, sizeof(passbuf))) {
                              close(cachefile);
                              if (debdev) debout("ru_save - cached password ok from %s", user);
                              return 0;
                           }
                           else {
                              if (debdev) debout("ru_save - incorrect password from %s", user);
                              return -1;
                           } 
                        }
                        else {
                           if (debdev) debout("ru_save - could not open the file for %s", user);
                           return -1;
                        }
                     }
                     else {
                        debout("ru_save - expired password for %s", user);
                        if (debdev) {
                           debout("ru_save - current time: %ld", timeb.tv_sec);
                           debout("ru_save - expiration time: %ld", 
                                             statb.st_mtime + time_mul * 60);
                        }
                        return -1;
                     }
                  }
                  else {
                     debout("ru_save - Cannot find %s's cached password", user);
                     if (debdev) {
                        debout("ru_save - If you are using an application that does not");
                        debout("ru_save - run as root (apache), check to see if the");
                        debout("ru_save - directory permissions are set properly.");
                     }
                     return -1;
                  }
               }

/* Save the password */
               else {
                  if (password) {
                     cachefile = open(tmp, O_WRONLY|O_CREAT, 0600);

                     if (cachefile) {
                        sprintf(passbuf, "%s", password);

                        if (
                        write(cachefile, (const void *)&passbuf,sizeof(passbuf)) == sizeof(passbuf)) {
				if (debdev) {
					debout("ru_save - caching password for %s", user);
					debout("ru_save - password for %s expires in %ld mins",
                                           user, time_mul);
				}
					   
                        }
                        else {
                           close(cachefile);
                           debout("ru_save - Could not write to save file.");
                           debout("ru_save - Reason: %s", strerror(errno));
                           return -1;
                        }

                        close(cachefile);
                        return 0;
                     }
                     else {
                        debout("ru_save - could not create cache file.");
                        return -1;
                     }
                  }
                  else {
                     /* Shouldn't happen */
                     debout("ru_save - Invalid password."); 
                     return -1;
                  }
               }   
            }
            else {
               debout("ru_save - Could not find host");
               return -1;
            }
         }
         else {
            /* Shouldn't happen */
            debout("ru_save - The value returned by PAM_RHOST is invalid");
            return -1;
         }
      }
      else {
         debout("ru_save - PAM_RHOST is not set.");
         return -1;
      }
   }
   else {
      debout("ru_save - Could not find the service name.");
      return -1;
   }
}
